 var FileAPI = {
   staticPath: '/static/lib/imagefileinput/FileAPI/',
 };

 $(document).ready(function() {

   $(".ifm").each(function() {
     $(this).ifm()

   })

 });
 $.fn.ifm = function() {

   var ifmpopupTemplate = function() {
     return '<div class="modal fade ifmmodal">' +
       '  <div class="modal-dialog">' +
       '    <div class="modal-content">' +
       '      <div class="modal-body"><div class="ifmcanvas"></div></div>' +
       '      <div class="modal-footer">' +
       '        <button type="button" class="btn btn-warning ifm-dx" ><i class="fa fa-repeat"></i></button>' +
       '        <button type="button" class="btn btn-warning ifm-sx"><i class="fa fa-undo"></i></button>' +
       '        <button type="button" class="btn btn-primary ifm-crop" data-dismiss="modal">' + cuttext + '</button>' +
       '        <button type="button" class="btn btn-link" data-dismiss="modal">Annulla</button>' +
       '      </div>' +
       '    </div>' +
       '  </div>' +
       '</div>'
   }

   var element = $(this)
   var inputfile = element.find("input[type=file]") //input del file
   var cuttext = inputfile.attr("cuttext") || "Ritaglia"
   var inputhidden = element.find("input[type=hidden]") //campo nascosto dove passare il base64
   var name = element.data("name") // name del field
     //dati presi dal widget
   var prevHeight = element.data("prev-height")
   var minh = element.data("minh")
   var minw = element.data("minw")
   var mode = element.data("mode") || "square"
   var maxh = element.data("maxh") || minh
   var maxw = element.data("maxw") || minw
   var aspectratio = element.data("aspectratio")
   if (aspectratio == -1) {
     aspectratio = false;
   }
   //div della preview che verra caricata
   var previewdiv = element.find(".ifmpreview")

   var info
   var cropping
   var scale_factor
   var resized
   var modale

   var sizecontrol = function(w1, w2, h1, h2) {
     //controlla le dimensioni minime, migliorare la modale?
     if (!(w1)) {
       alert("non è un img valida")
       return false
     }

     if (w1 < w2 || h1 < h2) {
       alert("img troppo piccola: " + w1 + "x" + h1 +
         " deve essere almeno: " + w2 + "x" + h2)
       return false
     }
     return true
   }

   var checkrotate = function(w1, w2, h1, h2) { //controlla se si puo ruotare in base alle size min
     if ((w1 < h2 || h1 < w2)) {
       return false
     }
     return true

   }

   //svuota per togliere img se not required
   element.find("input[type=checkbox]").change(function() {
     var state = element.find("input[type=checkbox]").prop("checked")
     if (state) {
       element.find(".ifmimgbtnorig").hide()
       element.find(".ifmimgbtnorigrestore").show()

       previewdiv.find(".ifmimgorig").hide()
       previewdiv.find(".ifmimgholder").show()
     }
     else {

       element.find(".ifmimgbtnorigrestore").hide()
       element.find(".ifmimgbtnorig").show()
       previewdiv.find(".ifmimgorig").show()
       previewdiv.find(".ifmimgholder").hide()

     }
   });
   //click oper cancellare img
   element.find(".ifmimgbtnorig").on("click", function(e) {
       element.find("input[type=checkbox]").prop("checked", true).change()
       return false
     })
     //undo cancellazione img
   element.find(".ifmimgbtnorigrestore").on("click", function(e) {
     element.find("input[type=checkbox]").prop("checked", false).change()
     return false
   })

   var preview = function() { //preview dell img da caricare
       element.trigger('preview');
       base64 = inputhidden.val()
       if (base64) { //nasconde la orig, aggiunge img preview e btn X
         element.trigger('preview_full');
         previewdiv.find(".ifmimgorig").hide()
         previewdiv.find(".ifmimgholder").hide()
         previewdiv.find(".ifmimgprew").remove()
         var tempimg = new Image();
         tempimg.onload = function() {
           newheight = prevHeight
           imgwidth = tempimg.width;
           imgheight = tempimg.height;
           if (imgwidth > imgheight) {
             var newheight = parseInt(prevHeight * imgheight / imgwidth)
           }
           previewdiv.append($("<img class='ifmimgprew' />"))
           previewdiv.find(".ifmimgprew").attr("src", base64)
           previewdiv.find("img").attr('height', newheight)
           element.trigger('preview_created', previewdiv.find(".ifmimgprew"));
         }
         tempimg.src = base64
         previewdiv.find("button").remove()
         previewdiv.append($("<button class='ifmimgbtn btn' />").html(
           '<i class="fa fa-close"></i>'))
         element.find("input[type=checkbox]").prop("checked", false);
         element.find(".ifmimgbtnorigrestore").hide()
         element.find(".ifmimgbtnorig").show()
         previewdiv.find(".ifmimgbtn").on("click", function() {
           element.find(".ifmspinner").remove()
           element.trigger('cancelupload');
           inputhidden.val("").change()
           preview()
           return false
         })

       }
       else { //se non ce preview toglie img btn e ripristina la orig
         element.trigger('preview_empty');
         previewdiv.find(".ifmimgorig").show()
         previewdiv.find(".ifmimgholder").show()
         previewdiv.find(".ifmimgprew").remove()
         previewdiv.find(".ifmimgbtn").remove()
       }
       element.trigger('preview_done');
     }
     //al change salva nel localstorage il base64 con key il nome del campo
   inputhidden.on("change", function() {
     var nome = inputhidden.attr("name")
     localStorage.setItem("art-" + nome, inputhidden.val())
     baseurl = previewdiv.find(".ifmimgorig").attr("src")
     localStorage.setItem("art-base-" + nome, baseurl)
   })

   //nel caso e salvato e si ritorna da un form in errore
   var saved = localStorage.getItem("art-" + inputhidden.attr("name"))
   if (saved && element.data("istemp") == "True") {
     inputhidden.val(saved)
       /*
	    in futuro per supportare anche la prima foto salvata
	    var getbaseurl = localStorage.getItem("art-base-" + inputhidden.attr("name"))
	    if (getbaseurl){
	      previewdiv.append("<img class='ifmimgorig' height=" + prevHeight +
	        " src='" + getbaseurl + "'>")
	        previewdiv.find(".ifmimgholder").remove()
	    }
	   */
     preview()
   }

   //al click sullo sfoglia
   inputfile.on("change", function(e) {

     var files = FileAPI.getFiles(inputfile)
     var file = files[0]
     var deg = 0
     var canrotate = true

     FileAPI.getInfo(file, function(err, success) { // info
       if (err) { //errore generale
         alert(err)
         inputfile.val("")
         return false
       }
       else {
         info = success
       }
       //controllo dimensioni
       control = sizecontrol(info.width, minw, info.height, minh)
         //controllo rotate
       canrotate = checkrotate(info.width, minw, info.height, minh)
         //errore dimensioni esce
       if (control == false) {
         inputfile.val("")
         return false
       }
       //http://stackoverflow.com/questions/20600800/js-client-side-exif-orientation-rotate-and-mirror-jpeg-images/20600801
       //considerati solo i casi 3 6 8
       if (info.exif) {
         if (info.exif.Orientation == 6) deg = 90
         if (info.exif.Orientation == 8) deg = -90
         if (info.exif.Orientation == 3) deg = 180
       }
       var scale = function(num) { //scala in base alla proporzione
         return num / scale_factor
       }
       var unscale = function(num) { //scala in base alla proporzione
         return num * scale_factor
       }

       var croppa = function() {
         //Calcola le proporzioni, fa il crop e poi scala,
         x = cropping.x * scale_factor
         y = cropping.y * scale_factor
         w = cropping.w * scale_factor
         h = cropping.h * scale_factor
         FileAPI.Image(file).rotate(deg).get(function(err, rotated) {
           if (err) console.log(err)
           var adw = parseInt(w + .5)
           var adh = parseInt(h + .5)
           if (adw > rotated.width) adw = rotated.width;
           if (adh > rotated.height) adh = rotated.height;
           FileAPI.Image(rotated).crop(x, y, adw, adh).get(function(err, cropped) {
             if (err) console.log(err)
               // w, h sono quelli definiti interattivamente dall'utente già scalati!!
               // per poterlo usare nel .resize()
             var user_ratio = w / h; // r = w/h
             var resize_w = w
             var resize_h = h
               // check: width selected may need some dowsn-scale
             if (w > maxw) {
               var resize_scale = w / maxw; // > 1 by definition
               resize_w = maxw;
               resize_h = h / resize_scale;
             }
             // check: height selected may need some down-scale
             if (resize_h > maxh) {
               var resize_scale = resize_h / maxh; // > 1 by definition
               resize_h = resize_h / resize_scale;
               resize_w = resize_w / resize_scale;
             }

             var resw = parseInt(resize_w + 0.5)
             var resh = parseInt(resize_h + 0.5)

             FileAPI.Image(cropped).resize(resw, resh).get(function(err, scaled) {
               if (err) consol.log(err)
                 //mette il base64 nell input e fa vedere la preview
               inputhidden.val(scaled.toDataURL("image/jpeg")).change()
               preview()
             })
           })
         })
       }
       var modalresize = function(modale) {
         //Corregge le dimensioni della modale
         width = modale.find("canvas").width()
         modale.find(".modal-body .ifmcanvas").width(width)
         modale.find(".modal-dialog").animate({
           width: width + 50
         })
       }
       var update = function(c) {
         $(".jcrop-keymgr").remove()
         if (mode == "circle") {
           if ($(".jcrop-holder div").first().find(".circle-crop").length ==
             0) {
             $(".jcrop-holder div").first().append(
               "<div class='circle-crop'></div>")
           }
         }
         cropping = c //alla selezione del crop
         modale.data("w", unscale(c.w))
         modale.data("h", unscale(c.h))
         modale.data("x", unscale(c.x))
         modale.data("y", unscale(c.y))
         modale.data("edit", "true")
       }
       var riduci = function(p, v) {
         return p - (v * p / 100)
       }
       var setcrop = function(modale) {
         //crea jcrop
         if (modale.find("canvas").data('Jcrop')) {
           modale.find("canvas").data('Jcrop').destroy();
         }
         var initw = riduci(modale.find("canvas").width(), 20)
         var inith = initw / aspectratio
         if (!(aspectratio)) inith = initw
         initselect = [0, 0, initw, inith]

         if (modale.data("edit") == "true") {
           /*	initselect = [scale($(modale).data("x")),
           	              scale($(modale).data("y")),
           	              scale($(modale).data("w")),
           	              scale($(modale).data("h"))]
           	              */
         }

         modale.find("canvas").Jcrop({
           onChange: update,
           minSize: [scale(minw), scale(minh)],
           onSelect: update,
           allowSelect: false,
           multi: false,
           shade: true,
           setSelect: initselect,
           allowMove: true,
           allowResize: true,
           aspectRatio: aspectratio
         });
       }
       var rotate = function(gradi) {
           deg = deg + gradi
           if (deg == 360) deg = 0
           FileAPI.Image(file).rotate(deg).get(function(err, rotated) {
             if (err) console.log(err)
             winwidth = $(window).width() - 70
             FileAPI.Image(rotated).resize(winwidth, $(window).height() - 150, 'max').get(function(err, canvas) { //resize
               if (err) console.log(err)
               scale_factor = rotated.width / canvas.width //proporzione
               modale.find(".modal-body .ifmcanvas").html("")
               modale.find(".modal-body .ifmcanvas").append(canvas)
               modalresize(modale)
               setcrop(modale)
             })
           })

         }
         //Crea la modale
       modale = $(ifmpopupTemplate()).clone()
       if (canrotate == false) {
         modale.find(".ifm-dx").attr("disabled", "disabled")
         modale.find(".ifm-sx").attr("disabled", "disabled")
       }
       modale.on('hidden.bs.modal', function(event) {
         //alla chiusura della modale pulisce il campo
         $(window).off("resize");
         inputfile.val("")
         modale.remove()
       });
       //al click croppa
       modale.find(".ifm-crop").on("click", function() {
           croppa()
         })
         //bottoni rotate
       modale.find(".ifm-dx").on("click", function() {
         rotate(90)
         return false
       })
       modale.find(".ifm-sx").on("click", function() {
         rotate(-90)
         return false
       })
       var initcrop = function() {
         //fa il resize in base al size della finestra
         FileAPI.Image(file).rotate(deg).get(function(err, rotated) {
           if (err) console.log(err)
           winwidth = $(window).width() - 70
           FileAPI.Image(rotated).resize(winwidth, $(window).height() - 150, 'max').get(function(err, canvas) { //resize
             if (err) console.log(err)
             scale_factor = rotated.width / canvas.width //proporzione
             modale.find(".modal-body .ifmcanvas canvas").remove()
             modale.find(".modal-body .ifmcanvas").append(canvas)

             modale.on('shown.bs.modal', function(event) {
               modalinit(modale)
             });
             //apre la modale
             modale.modal("show")
           })
         })
       }

       var modalinit = function(modale) {
         $(window).off("resize");
         $(window).resize(_.debounce(function() {

           FileAPI.Image(file).rotate(deg).get(function(err, rotated) {
             if (err) console.log(err)
             winwidth = $(window).width() - 70
             FileAPI.Image(rotated).resize(winwidth,
               $(window).height() - 150, 'max').get(
               function(err, canvas) { //resize
                 if (err) console.log(err)
                 scale_factor = rotated.width / canvas.width //proporzione
                 modale.find(".modal-body .ifmcanvas").html("")
                 modale.find(".modal-body .ifmcanvas").append(canvas)
                 modalresize(modale)
                 setcrop(modale)
               })
           })

           modalresize(modale)
         }, 500));

         $(window).resize(function() {

         });

         modalresize(modale)
         setcrop(modale)
       }

       initcrop();
     });

   })

 };
