# -*- coding: utf-8 -*-
from django.conf import settings
from django.utils.translation import ugettext as _
from django.conf.urls import url, include, patterns
from django.contrib import admin
from django.views.generic import TemplateView

from jmb.fileapitest.views import FileapitestCreate, FileapitestUpdate
from jmb.fileapitest.forms import FileapitestForm2

urlpatterns = patterns('',
   url(r'^$',  TemplateView.as_view(template_name="fileapitest/fileapitestmain.html"), name='fileapitest-main'), 
    
   url(r'add/$', FileapitestCreate.as_view(), name='fileapitest-add'),   
   url(r'add2/$', FileapitestCreate.as_view(form_class=FileapitestForm2), name='fileapitest-add2'),    
   
   url(r'update/(?P<pk>[0-9]+)/$', FileapitestUpdate.as_view(), name='fileapitest-update'),   
   url(r'update2/(?P<pk>[0-9]+)/$', FileapitestUpdate.as_view(form_class=FileapitestForm2), name='fileapitest-update2'),  
              
)

#if settings.CMS_ENABLED:
#    from namespace.appname.cms import urls
#    urlpatterns += urls.urlpatterns
