# -*- coding: utf-8 -*-
from django import forms

from jmb.fileapitest.models import Fileapitest
from jmb.fileapi.widgets import ImageFileInput

class FileapitestForm(forms.ModelForm):
      
    class Meta:
        model = Fileapitest
        fields = ['file',]
        widgets = {
            'file': ImageFileInput(
                attrs={'minw':350,
                       'minh': 350,
                       'mode': 'circle',
                       'cuttext': "Carica e Testa",
                       'prev-height': 150, 
                       'icon': 'camera-retro',
                        'aspectratio': 1}),
        }
        
class FileapitestForm2(FileapitestForm):
        class Meta:
            model = Fileapitest
            fields = ['file',]
            widgets = {
                'file': ImageFileInput(
                    attrs={'minw':350,
                           'minh': 350,
                           'maxw':1000,
                           'maxh': 1000,
                           'prev-height': 250,
                           'prev-width': 450,  
                           'icon': 'camera-retro',
                            'aspectratio': -1}),
            }
    